function show_notification(message, time)
{
	var notification = "<div class=\"notification-border\"><div class=\"notification\">" + message + "</div></div>";
	$("#notification_box").append(notification);
	$("#notification_box div.notification-border:last").hide().fadeIn(300, function()
	{
		$(this).delay(time).slideUp(300, function()
		{
			$(this).remove();
		});
	});
	$("#notification_box div.notification:last").hover(
		function()
		{
			$(this).stop().fadeTo(300, 0.5);
		},
		function()
		{
			$(this).stop().fadeTo(300, 1.0);
		}
	);
}

function show_notification_success(message, time)
{
	show_notification("<img alt=\"\" src=\"" + staticurl + "manager/img/apply.png\" /> <span style=\"vertical-align: middle;\">" + message + "</span>", time);
}

function show_notification_error(message, time)
{
	show_notification("<img alt=\"\" src=\"" + staticurl + "manager/img/cancel.png\" /> <span style=\"vertical-align: middle;\">" + message + "</span>", time);
}

$(function()
{
	var notification_box = $("<div id=\"notification_box\" class=\"notification-box\"/>");
	notification_box.appendTo(document.body);
	if(window["notification_message"] != undefined)
	{
		if(notification_message != "")
		{
			if(window["notification_status"] == undefined)
			{
				show_notification(notification_message, 8000);
			}
			else if(notification_status == "success")
			{
				show_notification_success(notification_message, 8000);
			}
			else if(notification_status == "error")
			{
				show_notification_error(notification_message, 8000);
			}
			else
			{
				show_notification(notification_message, 8000);
			}
		}
	}
});
