result_id = [];
result_formats = [];
result_properties = [];
barchart_results = [];
ans_count = 0;
result_count = 0;
survey_status = "0";
ajrequest_handler = null;
ajrequest_timeout = null;

attachments = [];

zoomed_res = null;
zoomed_qr = null;

blind_width = 0;
blind_leftmargin = 0;
blind_rightmargin = 0;

function refresh_chart(qid, fontsize)
{
	if(result_formats[qid] == "1")
	{
		var data = [];
		for(j in barchart_results[qid])
			data.push([barchart_results[qid][j], j]);
		$.jqplot("resultchart_" + qid, [data], bar_chart(ans_count, fontsize)).replot();
	}
	else if(result_formats[qid] == "2")
	{
		var data = [];
		for(j in barchart_results[qid])
			data.unshift([barchart_results[qid][j], result_properties[qid][j]]);
		$.jqplot("resultchart_" + qid, [data], bar_chart(ans_count, fontsize)).replot();
	}
	else if(result_formats[qid] == "3")
	{
		var data = [];
		for(j in barchart_results[qid])
			data.unshift([barchart_results[qid][j], result_properties[qid][j]]);
		$.jqplot("resultchart_" + qid, [data], bar_chart_count(fontsize)).replot();
	}
}

function refresh_charts()
{
	for(qid in barchart_results)
	{
		fontsize = $("#result_" + qid + " .qtitle").css("font-size");
		refresh_chart(qid, fontsize);
	}
}

function clear_results()
{
	for(qid in result_formats)
	{
		if(result_formats[qid] == 0 || result_formats[qid] == 4)
		{
			$("#result_" + qid + " ul").empty();
		}
		else if(result_formats[qid] == 1 || result_formats[qid] == 2 || result_formats[qid] == 3)
		{
			for(t in barchart_results[qid])
			{
				barchart_results[qid][t] = 0;
			}
		}
	}
	ans_count = 0;
	result_count = 0;
	refresh_charts();
}

function add_result()
{
	first_ans = false;
	for(qid in result_formats)
	{
		var text = $(this).find("q" + qid).text();
		if(result_formats[qid] == 0)
		{
			if(text != "")
			{
				first_ans = true;
				var item = "<li class=\"result-text-item\">" + text + "</li>";
				$("#result_" + qid + " ul").append(item);
			}
		}
		else if(result_formats[qid] == 1)
		{
			if(text != "-1")
			{
				first_ans = true;
				barchart_results[qid][text] += 1;
			}
		}
		else if(result_formats[qid] == 2)
		{
			if(text != "-1")
			{
				first_ans = true;
				barchart_results[qid][text] += 1;
			}
		}
		else if(result_formats[qid] == 3)
		{
			if(text != "")
			{
				first_ans = true;
				options = text.split(",");
				for(t in options)
				{
					barchart_results[qid][options[t]] += 1;
				}
			}
		}
		else if(result_formats[qid] == 4)
		{
			if(text != "")
			{
				var item = "<li class=\"result-text-item\">" + text + "</li>";
				$("#result_" + qid + " ul").prepend(item);
			}
		}
	}
	if(first_ans)
		ans_count++;
	result_count++;
}

function get_results(xml, status)
{
	if(status != "success")
		return;
	
	$(xml).find("result").each(add_result);
	$("#nor").text(ans_count);
	refresh_charts();
	if(survey_status == "1")
	{
		ajrequest_timeout = setTimeout(function() {
			ajrequest_handler = $.ajax({url: "./" + surveyid + "/+result?start=" + result_count, cache: false, type: "get", dataType: "xml", timeout: 10000, success: get_results});
		}, 5000);
	}
}

function remove_pages(qid)
{
	$("#pdf_" + qid).empty();
}

function add_pages(qid, attacheduuid, width)
{
	for(pagenum in attachments[qid][1])
	{
		var imgwidth = width < 1000 ? width : 1000;
		var height = parseInt(width * attachments[qid][1][pagenum])
		pagetag =
			"<li class=\"pdfpage\" style=\"height: " + height + "px\">" +
			"	<img alt=\"Page " + (parseInt(pagenum) + 1) + "\" src=\"" + staticurl + "manager/img/dummy.png\" data-original=\"../attachment/" + attachments[qid][0] + "/+png?width=" + imgwidth + "&page=" + pagenum + "\" width=\"" + width + "\" height=\"" + height + "\" />" +
			"</li>";
		$("#pdf_" + qid).append(pagetag);
	}
	$("#pdf_" + qid + " li").css({"width": width})
}

number = 1;

function get_item_tag(qid, question, format, property, attacheduuid)
{
	var b;
	if(format == "0")
	{
		b = "<ul id=\"resulttexts_" + qid + "\" class=\"result-text\"></ul>";
	}
	else if(format == "1")
	{
		b = "<div id=\"resultchart_" + qid + "\" class=\"result-chart\" style=\"overflow-x: hidden; overflow-y: hidden;\"></div>";
	}
	else if(format == "2")
	{
		b = "<div id=\"resultchart_" + qid + "\" class=\"result-chart\"></div>";
	}
	else if(format == "3")
	{
		b = "<div id=\"resultchart_" + qid + "\" class=\"result-chart\"></div>";
	}
	else if(format == "4")
	{
		b = "<ul id=\"resulttexts_" + qid + "\" class=\"result-text\"></ul>";
	}
	if(attacheduuid != "")
	{
		var item =
			"<div id=\"result_" + qid + "\" class=\"result\" style=\"width: 794px;\">" +
			"	<div>" +
			"		<table class=\"result-holder\">" +
			"			<tr>" +
			"				<td class=\"qicon\"><a href=\"javascript:void(0)\">Q" + number + "</a></td>" +
			"				<td class=\"qtitle\">" + question + "</td>" +
			"				<td class=\"qspace\"></td>" +
			"				<td class=\"qicon-attachment\"><a href=\"javascript:void(0)\">&nbsp;</a></td>" +
			"				<td class=\"qtitle\">" + gettext("Attachment") + "</td>" +
			"			</tr>" +
			"			<tr>" +
			"				<td colspan=\"2\">" +
			"					<div class=\"res-space\">" + b + "</div>" +
			"				</td>" +
			"				<td></td>" +
			"				<td colspan=\"2\">" +
			"					<div class=\"res-space\">" +
			"						<ul id=\"pdf_" + qid + "\" class=\"pdf-viewer\"></ul>";
			"					</div>" +
			"				</td>" +
			"			</tr>" +
			"		</table>" +
			"	</div>" +
			"</div>";
	}
	else
	{
		var item =
			"<div id=\"result_" + qid + "\" class=\"result\" style=\"width: 394px;\">" +
			"	<div>" +
			"		<table class=\"result-holder\">" +
			"			<tr>" +
			"				<td class=\"qicon\"><a href=\"javascript:void(0)\">Q" + number + "</a></td>" +
			"				<td class=\"qtitle\">" + question + "</td>" +
			"			</tr>" +
			"			<tr>" +
			"				<td colspan=\"2\">" +
			"					<div class=\"res-space\">" + b + "</div>" +
			"				</td>" +
			"			</tr>" +
			"		</table>" +
			"	</div>" +
			"</div>";
	}
	number++;
	return item;
}

function add_question()
{
	var qid = $(this).find("id").text();
	result_id.push(qid);
	var question = $(this).find("question").html();
	var format = $(this).find("format").text();
	var property = $(this).find("property").text();
	var attachment = $(this).find("attachment").text();
	var item = get_item_tag(qid, question, format, property, attachment);
	$("#results").append(item);
	if(attachment != "")
	{
		$.ajax({url: "../attachment/" + attachment + "/+xml", cache: true, type: "get", dataType: "xml", timeout: 10000, success: function(xml, status)
		{
			if(status != "success")
				return;
			var aspect = [];
			$(xml).find("page").each(function()
			{
				aspect.push(parseFloat($(this).find("height").text()) / parseFloat($(this).find("width").text()));
			});
			attachments[qid] = [attachment, aspect];
			add_pages(qid, attachment, 340);
			$("#pdf_" + qid + " img").lazyload({threshold: 500, appear_at_least: 500, container: $("#pdf_" + qid).parent("div")});
		}});
	}
	result_formats[qid] = format;
	if(format == "0" || format == "4")
	{
		result_properties[qid] = property;
	}
	else if(format == "1")
	{
		result_properties[qid] = property;
		var cols = [];
		for(i = 1; i <= property; i++)
		{
			cols[i] = 0;
		}
		barchart_results[qid] = cols;
	}
	else if(format == "2" || format == "3")
	{
		result_properties[qid] = property.split(",");
		var cols = [];
		for(i = 0; i < result_properties[qid].length; i++)
		{
			cols[i] = 0;
		}
		barchart_results[qid] = cols;
	}
}

function zoomin_result(elem, is_attachment)
{
	var qid = elem.parent("div").attr("id").split("_")[1];
	var maxwidth = $(window).width() - 100;
	var maxheight = $(window).height() - 40;
	if(qid in attachments)
	{
		var contentwidth = elem.innerWidth() / 2 - 3;
		var scrollH = $("#pdf_" + qid).parent("div")[0].scrollHeight - $("#pdf_" + qid).parent("div").innerHeight();
		if(scrollH == 0)
			var scrollpos = 0;
		else
			var scrollpos = $("#pdf_" + qid).parent("div").scrollTop() / scrollH;
	}
	else
	{
		var contentwidth = elem.innerWidth();
	}
	var elemwidth = elem.innerWidth();
	var elemheight = elem.innerHeight();
	if(maxwidth <= contentwidth || maxheight <= elemheight)
	{
		zoomed_res = null;
		return;
	}
	elem.parent("div").css({"height": elem.innerHeight()});
	if(maxwidth / maxheight <= contentwidth / elemheight)
		var scale = maxwidth / contentwidth;
	else
		var scale = maxheight / elemheight;
	elem.css({"width": scale * elemwidth, "position": "fixed", "left": "50%", "top": "50%", "z-index": "1000"});
	elem.find(".result-holder").css({"padding": scale * 5, "border": "solid " + parseInt(scale * 2) + "px #666", "border-spacing": parseInt(scale) + "px " + parseInt(scale * 5) + "px"});
	elem.find(".qicon").css({"width": scale * 40, "font-size": parseInt(scale * 16)});
	elem.find(".qicon a").css({"padding": parseInt(scale * 10)});
	elem.find(".qicon-attachment").css({"width": parseInt(scale * 40), "font-size": parseInt(scale * 16)});
	elem.find(".qicon-attachment a").css({"padding": parseInt(scale * 10)});
	elem.find(".qtitle").css({"padding-left": parseInt(scale * 10), "font-size": parseInt(scale * 10) + "pt"});
	elem.find(".qspace").css({"padding": scale * 10});
	elem.find(".res-space").css({"height": parseInt(scale * 250), "width": parseInt(scale * 376)});
	elem.find(".result-text").css({"font-size": parseInt(scale * 10) + "pt"});
	elem.find(".result-chart").css({"height": parseInt(scale * 250)});
	var hHeight = elem.innerHeight() / 2
	if(qid in attachments)
	{
		blind_width = elem.innerWidth() / 2 + 3 * scale;
		var hWidth = (elem.innerWidth() - blind_width) / 2;
		blind_leftmargin = -hWidth * 3 - 6 * scale;
		blind_rightmargin = hWidth;
		if(is_attachment)
		{
			elem.css({"margin-left": blind_leftmargin, "margin-top": -hHeight});
			$(".blind-left").css({"margin-left": blind_leftmargin, "margin-top": -hHeight, "width": blind_width, "height": 2 * hHeight});
			$(".blind-right").css({"margin-left": blind_rightmargin, "margin-top": -hHeight, "width": 0, "height": 2 * hHeight});
		}
		else
		{
			elem.css({"margin-left": blind_leftmargin+blind_width, "margin-top": -hHeight});
			$(".blind-left").css({"margin-left": blind_leftmargin+blind_width, "margin-top": -hHeight, "width": 0, "height": 2 * hHeight});
			$(".blind-right").css({"margin-left": blind_rightmargin, "margin-top": -hHeight, "width": blind_width, "height": 2 * hHeight});
		}
		$(".blind-left").fadeIn(300);
		$(".blind-right").fadeIn(300);
	}
	else
	{
		var hWidth = elem.innerWidth() / 2;
		elem.css({"margin-left": -hWidth, "margin-top": -hHeight});
		if(qid in attachments)
		{
			$(".blind-left").css({"margin-left": -hWidth * 3, "margin-top": -hHeight, "width": 0, "height": 2 * hHeight});
			$(".blind-right").css({"margin-left": -hWidth + scale * elemwidth, "margin-top": -hHeight, "width": scale * (elemwidth + 6), "height": 2 * hHeight});
		}
	}
	refresh_chart(qid, parseInt(scale * 10) + "pt");
	$(".modal").fadeIn(300);
	elem.hide()
	elem.fadeIn(300);
	if(qid in attachments)
	{
		remove_pages(qid);
		pdfspacewidth = $("#pdf_" + qid).parent("div").innerWidth();
		add_pages(qid, attachments[qid], pdfspacewidth - 36);
		var scrollH = $("#pdf_" + qid).parent("div")[0].scrollHeight - $("#pdf_" + qid).parent("div").innerHeight();
		$("#pdf_" + qid).parent("div").scrollTop(scrollH * scrollpos);
		$("#pdf_" + qid + " img").lazyload({threshold: pdfspacewidth * 1.5, appear_at_least: 500, container: $("#pdf_" + qid).parent("div")});
	}
}

function zoomout_result(elem)
{
	var qid = elem.parent("div").attr("id").split("_")[1];
	if(qid in attachments)
	{
		var scrollH = $("#pdf_" + qid).parent("div")[0].scrollHeight - $("#pdf_" + qid).parent("div").innerHeight();
		if(scrollH == 0)
			var scrollpos = 0;
		else
			var scrollpos = $("#pdf_" + qid).parent("div").scrollTop() / scrollH;
		$(".blind-left").fadeOut(300);
		$(".blind-right").fadeOut(300);
	}
	elem.fadeOut(300, function() {
		if(qid in attachments)
		{
			elem.css({"width": "794px", "position": "static", "z-index": "0", "margin": "0"});
		}
		else
		{
			elem.css({"width": "394px", "position": "static", "z-index": "0", "margin": "0"});
		}
		elem.find(".result-holder").css({"padding": "5px", "border": "solid 2px #666", "border-spacing": "1px 5px"});
		elem.find(".qicon").css({"width": "40px", "font-size": "16px"});
		elem.find(".qicon a").css({"padding": "10px"});
		elem.find(".qicon-attachment").css({"width": "40px", "font-size": "16px"});
		elem.find(".qicon-attachment a").css({"padding": "10px"});
		elem.find(".qtitle").css({"padding-left": "10px", "font-size": "10pt"});
		elem.find(".qspace").css({"padding": 10});
		elem.find(".res-space").css({"height": "250px", "width": "376px"});
		elem.find(".result-text").css({"font-size": "10pt"});
		elem.find(".result-chart").css({"height": "250px"});
		elem.show();
		refresh_chart(qid, "10pt");
		if(qid in attachments)
		{
			remove_pages(qid);
			add_pages(qid, attachments[qid], 340);
			var scrollH = $("#pdf_" + qid).parent("div")[0].scrollHeight - $("#pdf_" + qid).parent("div").innerHeight();
			$("#pdf_" + qid).parent("div").scrollTop(scrollH * scrollpos);
			$("#pdf_" + qid + " img").lazyload({threshold: 500, appear_at_least: 500, container: $("#pdf_" + qid).parent("div")});
		}
		zoomed_res = null;
		elem.hide()
		elem.fadeIn(300);
	});
}

function zoomin_qrcode(elem)
{
	var maxwidth = $(window).width() - 100;
	var maxheight = $(window).height() - 100;
	var contentsize = elem.innerWidth();
	if(maxwidth / maxheight <= 1)
		var scale = maxwidth / contentsize;
	else
		var scale = maxheight / contentsize;
	if(maxwidth <= contentsize || maxheight <= contentsize)
	{
		return;
	}
	elem.css({"position": "fixed", "left": "50%", "top": "50%", "z-index": "1000"});
	elem.find("#qrimage").css({"padding": 20 * scale});
	elem.find("img").css({"width": 120 * scale});
	var hWidth = elem.innerWidth() / 2;
	var hHeight = elem.innerHeight() / 2;
	elem.css({"margin-left": -hWidth, "margin-top": -hHeight});
	$(".modal").fadeIn(300);
	elem.hide().fadeIn(300);
	zoomed_qr = elem;
}

function zoomout_qrcode(elem)
{
	elem.fadeOut(300, function() {
		elem.css({"position": "static", "z-index": 0, "margin": 0});
		elem.find("#qrimage").css({"padding": "5px 20px"});
		elem.find("img").css({"width": 120});
		elem.hide();
		elem.fadeIn(300);
		zoomed_qr = null;
	});
}

function get_sheet(xml, status)
{
	if(status != "success")
		return;
	$(xml).find("item").each(add_question);

	$(".qicon").click(function() {
		if(zoomed_res)
		{
			zoomout_result(zoomed_res);
			if(!zoomed_qr)
				$(".modal").fadeOut(300);
		}
		else
		{
			zoomed_res = $(this).closest("div");
			zoomin_result(zoomed_res, false);
		}
	});

	$(".qicon-attachment").click(function() {
		if(zoomed_res)
		{
			zoomout_result(zoomed_res);
			if(!zoomed_qr)
				$(".modal").fadeOut(300);
		}
		else
		{
			zoomed_res = $(this).closest("div");
			zoomin_result(zoomed_res, true);
		}
	});
	
	ajrequest_handler = $.ajax({url: "./" + surveyid + "/+result", cache: false, type: "get", dataType: "xml", timeout: 10000, success: get_results});
}

function get_survey(xml, status)
{
	if(status != "success")
		return;
	$("#title").text($(xml).find("title").text());
	survey_status = $(xml).find("status").text();
	if(survey_status == "1")
	{
		$(".toolbox #start").css({"display": "none"});
		$(".toolbox #stop").css({"display": "block"});
	}
	$.ajax({url: "../sheet/" + sheetid + "/+xml", cache: false, type: "get", dataType: "html", timeout: 10000, success: get_sheet});
}

function process_message(xml, status, senddata)
{
	if(status != "success")
		return;
	var status = $(xml).find("status").text();
	var command = $(xml).find("command").text();
	var message = $(xml).find("message").text();
	if(status == "success")
	{
		if(command == "jump")
		{
			location.href = message;
			return;
		}
		show_notification_success(message, 10000);
	}
	else if(status == "error")
	{
		if(command == "auth")
			submit_array(message, senddata);
		show_notification_error(message, 10000);
	}
}

$(function() {
	$(".toolbox #start").click(function() {
		var senddata = {};
		var anmobj = proccess_start($(".toolbox #start .process-container"));
		senddata["mode"] = "start";
		senddata["csrfmiddlewaretoken"] = $.cookie("csrftoken");
		$.post("./" + surveyid + "/+edit?result=xml", senddata, function(xml, status)
		{
			process_message(xml, status, senddata);
			var status = $(xml).find("status").text();
			if(status == "success")
			{
				$(".toolbox #start").css({"display": "none"});
				$(".toolbox #stop").css({"display": "block"});
				survey_status = "1"
				$.ajax({url: "./" + surveyid + "/+result?start=" + result_count, cache: false, type: "get", dataType: "xml", timeout: 10000, success: get_results});
			}
			proccess_stop(anmobj);
		}, "xml");
	});

	$(".toolbox #stop").click(function() {
		var senddata = {};
		var anmobj = proccess_start($(".toolbox #start .process-container"));
		senddata["mode"] = "stop";
		senddata["csrfmiddlewaretoken"] = $.cookie("csrftoken");
		$.post("./" + surveyid + "/+edit?result=xml", senddata, function(xml, status)
		{
			process_message(xml, status, senddata);
			var status = $(xml).find("status").text();
			if(status == "success")
			{
				$(".toolbox #start").css({"display": "block"});
				$(".toolbox #stop").css({"display": "none"});
				survey_status = "2"
			}
			proccess_stop(anmobj);
		}, "xml");
	});

	$(".toolbox #reset").click(function() {
		if(!confirm(gettext("Are you sure you want to remove results?")))
			return;
		var senddata = {};
		var anmobj = proccess_start($(".toolbox #reset .process-container"));
		senddata["mode"] = "reset";
		senddata["csrfmiddlewaretoken"] = $.cookie("csrftoken");
		$.post("./" + surveyid + "/+edit?result=xml", senddata, function(xml, status)
		{
			process_message(xml, status, senddata);
			var status = $(xml).find("status").text();
			if(status == "success")
			{
				clearTimeout(ajrequest_timeout);
				ajrequest_handler.abort()
				clear_results()
				ajrequest_handler = $.ajax({url: "./" + surveyid + "/+result", cache: false, type: "get", dataType: "xml", timeout: 10000, success: get_results});
			}
			proccess_stop(anmobj);
		}, "xml");
	});
	
	$(".qrcode #qrimage").click(function() {
		if(zoomed_qr)
		{
			zoomout_qrcode($(this).closest("div"));
			if(!zoomed_res)
				$(".modal").fadeOut(300);
		}
		else
		{
			zoomin_qrcode($(this).closest("div"));
		}
		return false;
	});

	$(".modal").click(function() {
		$(".modal").fadeOut(300);
		if(zoomed_qr)
		{
			zoomout_qrcode(zoomed_qr);
		}
		if(zoomed_res)
		{
			zoomout_result(zoomed_res);
		}
	});

	$(".blind-left").click(function() {
		if(zoomed_res)
		{
			zoomed_res.animate({"margin-left": blind_leftmargin+blind_width}, {"duration": 500, "easing": "swing"});
			$(".blind-left").animate({"margin-left": blind_leftmargin+blind_width, "width": 0}, {"duration": 500, "easing": "swing"});
			$(".blind-right").animate({"margin-left": blind_rightmargin, "width": blind_width}, {"duration": 500, "easing": "swing"});
		}
	});

	$(".blind-right").click(function() {
		if(zoomed_res)
		{
			zoomed_res.animate({"margin-left": blind_leftmargin}, {"duration": 500, "easing": "swing"});
			$(".blind-left").animate({"margin-left": blind_leftmargin, "width": blind_width}, {"duration": 500, "easing": "swing"});
			$(".blind-right").animate({"margin-left": blind_rightmargin, "width": 0}, {"duration": 500, "easing": "swing"});
		}
	});
	
	$.ajax({url: "./" + surveyid + "/+xml", cache: false, type: "get", dataType: "xml", timeout: 10000, success: get_survey});
});
