from django import template
from django.utils.safestring import mark_safe
from django.template.base import Node

register = template.Library()

class Footer(Node):
	def render(self, context):
		footer = """
		<hr />
		<p>(C) 2012 Koichi Akabe.<br />Unaju 0.1</p>
		"""
		return mark_safe(footer)

@register.tag
def header(parser, token):
	return Header()
	
@register.tag
def footer(parser, token):
	return Footer()
