from django.db import connection, transaction
	
def addnew_to_survey_table(survey, values):
	cursor = connection.cursor()
	sheet = survey.sheet
	questions = sheet.question_set.all()
	cols = []
	vals = []
	for q in questions:
		cols.append("q_%d" % q.id)
		vals.append("%s")
	query = "INSERT INTO survey_%d (%s) VALUES (%s)" % (survey.id, ", ".join(cols), ", ".join(vals))
	cursor.execute(query, values)
	transaction.commit_unless_managed()

