/*
 * Lazy Load - jQuery plugin for lazy loading images
 *
 * This is a modified version by Koichi Akabe
 *
 * Copyright (c) 2007-2012 Mika Tuupola
 * Copyright (c) 2012 Koichi Akabe
 *
 * Licensed under the MIT license:
 *   http://www.opensource.org/licenses/mit-license.php
 *
 * Project home:
 *   http://www.appelsiini.net/projects/lazyload
 *
 * Version:  1.8.2
 *
 */
(function(c,b,a,e){var d=c(b);c.fn.lazyload=function(f){var h=this;var i;var g={threshold:0,failure_limit:0,appear_at_least:0,event:"scroll",effect:"show",container:b,data_attribute:"original",skip_invisible:true,appear:null,load:null};function j(l){var k=0;h.each(function(){var n=c(this);if(g.skip_invisible&&!n.is(":visible")){return}if(c.abovethetop(this,g)||c.leftofbegin(this,g)){}else{if(!c.belowthefold(this,g)&&!c.rightoffold(this,g)){if(g.appear_at_least==0||l){n.trigger("appear")}else{var m=this;setTimeout(function(){if(c.abovethetop(m,g)||c.leftofbegin(m,g)){}else{if(!c.belowthefold(m,g)&&!c.rightoffold(m,g)){n.trigger("appear");k=0}}},g.appear_at_least)}}else{if(++k>g.failure_limit){return false}}}})}if(f){if(e!==f.failurelimit){f.failure_limit=f.failurelimit;delete f.failurelimit}if(e!==f.effectspeed){f.effect_speed=f.effectspeed;delete f.effectspeed}c.extend(g,f)}i=(g.container===e||g.container===b)?d:c(g.container);if(0===g.event.indexOf("scroll")){i.bind(g.event,function(k){return j(false)})}this.each(function(){var k=this;var l=c(k);k.loaded=false;l.one("appear",function(){if(!this.loaded){if(g.appear){var m=h.length;g.appear.call(k,m,g)}c("<img />").bind("load",function(){l.hide().attr("src",l.data(g.data_attribute))[g.effect](g.effect_speed);k.loaded=true;var n=c.grep(h,function(p){return !p.loaded});h=c(n);if(g.load){var o=h.length;g.load.call(k,o,g)}}).attr("src",l.data(g.data_attribute))}});if(0!==g.event.indexOf("scroll")){l.bind(g.event,function(m){if(!k.loaded){l.trigger("appear")}})}});d.bind("resize",function(k){j(true)});if((/iphone|ipod|ipad.*os 5/gi).test(navigator.appVersion)){d.bind("pageshow",function(k){if(k.originalEvent.persisted){h.each(function(){c(this).trigger("appear")})}})}c(a).ready(function(){j(true)});return this};c.belowthefold=function(g,h){var f;if(h.container===e||h.container===b){f=d.height()+d.scrollTop()}else{f=c(h.container).offset().top+c(h.container).height()}return f<=c(g).offset().top-h.threshold};c.rightoffold=function(g,h){var f;if(h.container===e||h.container===b){f=d.width()+d.scrollLeft()}else{f=c(h.container).offset().left+c(h.container).width()}return f<=c(g).offset().left-h.threshold};c.abovethetop=function(g,h){var f;if(h.container===e||h.container===b){f=d.scrollTop()}else{f=c(h.container).offset().top}return f>=c(g).offset().top+h.threshold+c(g).height()};c.leftofbegin=function(g,h){var f;if(h.container===e||h.container===b){f=d.scrollLeft()}else{f=c(h.container).offset().left}return f>=c(g).offset().left+h.threshold+c(g).width()};c.inviewport=function(f,g){return !c.rightoffold(f,g)&&!c.leftofbegin(f,g)&&!c.belowthefold(f,g)&&!c.abovethetop(f,g)};c.extend(c.expr[":"],{"below-the-fold":function(f){return c.belowthefold(f,{threshold:0})},"above-the-top":function(f){return !c.belowthefold(f,{threshold:0})},"right-of-screen":function(f){return c.rightoffold(f,{threshold:0})},"left-of-screen":function(f){return !c.rightoffold(f,{threshold:0})},"in-viewport":function(f){return c.inviewport(f,{threshold:0})},"above-the-fold":function(f){return !c.belowthefold(f,{threshold:0})},"right-of-fold":function(f){return c.rightoffold(f,{threshold:0})},"left-of-fold":function(f){return !c.rightoffold(f,{threshold:0})}})})(jQuery,window,document);
