from django.http import HttpResponseForbidden
from django.template import Context
from django.template.loader import get_template
from manager.utils.exceptions import Http403

class ExceptionMiddleware(object):
	def process_exception(self, request, e):
		if isinstance(e, Http403):
			c = {}
			return HttpResponseForbidden(get_template("403.html"), Context(c))
		else:
			return None
